--- !ditz.rubyforge.org,2008-03-06/issue 
title: Determine what patterns of pixels to support, and how to support them (see also {issue cd8cda126db604feda8a481b2022490311624cb9}).
desc: |-
  For loading and caching performance, the arrangement of pixels in memory could
  be important.  Determine what mechanism should be used for pattern
  determination (e.g., allowing client code to select a pattern), and what sorts
  of patterns should be provided for (e.g., one of a fixed set, or perhaps based
  on provided client code).  Obvious approaches would include interleaving digits
  (e.g., bits) of horizontal and vertical coordinates, or other mapping providing
  a monotonic relationship between each coordinate and the resulting index.
type: :task
component: libale
release: 
reporter: David Hilvert <dhilvert@auricle.dyndns.org>
status: :unstarted
disposition: 
creation_time: 2009-02-22 10:10:45.773096 Z
references: []

id: 8070953002a30b1d6faaba9ce23d615804252165
log_events: 
- - 2009-02-22 10:10:46.821539 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - created
  - ""
- - 2009-02-22 10:16:24.980467 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Keith Packard comments briefly somewhere on-line regarding the approaches to
    pixel patterns (via bit swizzling) taken in the Intel video drivers.  If I
    recall correctly, he describes two patterns used, one more square and one more
    rectangular, each having something on the order of 300 pixels in each
    dimension.
- - 2009-02-23 11:55:28.207865 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    A reasonable approach might involve two API functions available to client code,
    one for setting the format without changing any memory structures, and one for
    re-arranging the memory structure to reflect a new format.  E.g.,
    
    ale_image_set_pattern(...)
    
    ale_image_repattern(...)
    
    In this way, details regarding how patterns are represented could be left for
    later.  (In particular, integration with ALE could proceed mostly independently
    of API and implementation of this feature.)
git_branch: 
